#include <Xm/Xm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>

#include "defines.h"
#include "dircmd.h"
#include "getinfo.h"
#include "filecmd.h"
#include "findfile.h"
#include "helpsys.h"
#include "nfs.h"
#include "smbconfig.h"
#include "smbshare.h"

extern Widget fm_container;
extern char current_wd[120];

void MenuCallback(Widget w, XtPointer client_data, XtPointer call_data)
{
  char *thisfile, *fullpath;
  WidgetList sel_wid;
  int sel_wid_count;

  XtVaGetValues(fm_container, XmNselectedObjects, &sel_wid, 
		XmNselectedObjectCount, &sel_wid_count, NULL);

  if (sel_wid_count)
    thisfile = (char *)malloc (sizeof(char) * strlen(XtName(sel_wid[0])));
  fullpath = (char *)malloc (sizeof(char) * 150);

  if (sel_wid_count == 0) {
    switch ((int) client_data) {
    case FILE_MENU_COPY:
      CopyFile(NULL);
      break;
    case FILE_MENU_MOVE:
      MoveFile(NULL);
      break;
    case FILE_MENU_INFO:
      sprintf(fullpath, "%s", current_wd);
      display_info(fullpath);
      free(fullpath);
      break;
    case FILE_MENU_FIND:
      FindFileDialog();
      break;
    case FILE_MENU_EXIT:
      exit(0);
    case DIR_CREATE:
      dir_create_func();
      break;
    case DIR_GOTO:
      chdir_goto();
      break;
    case DIR_HOME:
      chdir_home();
      break;
    case DIR_UPONE:
      chdir_up();
      break;
    case SHARE_SMB_ADDSHARE:
      SMB_add_share(NULL);
      break;
    case SHARE_SMB_LISTSHARES:
      SMB_list_shares();
      break;
    case SHARE_SMB_CONFIG:
      SMB_server_config();
      break;
    case SHARE_NFS_CONFIG:
      nfs_server_config();
      break;
    case FILE_MENU_RUN:
      RunUnselectedFile();
      break;
    case HELP_MENU_GENERAL:
      GeneralHelp();
      break;
    case HELP_MENU_ABOUT:
      HelpAbout();
      break;
    }
    return;
  }

  strcpy(thisfile, XtName(sel_wid[0]));
  if (strcmp(current_wd, "/") == 0)
    sprintf(fullpath, "/%s", thisfile);
  else
    sprintf(fullpath, "%s/%s", current_wd, thisfile);
  free(thisfile);

#ifdef DEBUG
  printf("%s\n", fullpath);
#endif

  switch ((int) client_data) {
  case FILE_MENU_RUN:
    RunSelectedFile(fullpath);
    break;
  case FILE_MENU_COPY:
    CopyFile(fullpath);
    break;
  case FILE_MENU_MOVE:
    MoveFile(fullpath);
    break;
  case FILE_MENU_DELETE:
    DeleteFile(fullpath);
    break;
  case FILE_MENU_INFO:
    display_info(fullpath);
    break;
  case FILE_MENU_FIND:
    FindFileDialog();
    break;
  case FILE_MENU_EXIT:
    exit(0);
  case DIR_CREATE:
    dir_create_func();
    break;
  case DIR_GOTO:
    chdir_goto();
    break;
  case DIR_HOME:
    chdir_home();
    break;
  case DIR_UPONE:
    chdir_up();
    break;
  case SHARE_SMB_ADDSHARE:
    SMB_add_share(fullpath);
    break;
  case SHARE_SMB_LISTSHARES:
    SMB_list_shares();
    break;
  case SHARE_SMB_CONFIG:
    SMB_server_config();
    break;
  case SHARE_NFS_CONFIG:
    nfs_server_config();
    break;
  case HELP_MENU_GENERAL:
    GeneralHelp();
    break;
  case HELP_MENU_ABOUT:
    HelpAbout();
    break;
  }
  free(fullpath);
}








